Object subclass: #Club
	instanceVariableNames: 'tarifaSocio tarifaSocioVIP recaudacionTotal socios nombre'
	classVariableNames: ''
	package: 'tp0.5-Modelo'!
!Club commentStamp: 'ScopaAlejandro 4/26/2020 22:17' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State a one line summary. For example, "I represent a paragraph of text".

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 
a
Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	nombre:		<Object>
	recaudacionTotal:		<Object>
	socios:		<Object>
	tarifaSocio:		<Object>
	tarifaSocioVIP:		<Object>


    Implementation Points!


!Club methodsFor: 'accessing' stamp: 'ScopaAlejandro 4/27/2020 00:09'!
recibirPagoDe: unaPersona
	self sumarPagoAClub: unaPersona.
	self sumarPagoAPersona: unaPersona.
	! !


!Club methodsFor: 'initialization' stamp: 'ScopaAlejandro 4/26/2020 19:40'!
initialize 
	socios  := OrderedCollection new.
	recaudacionTotal:=0.! !


!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/27/2020 00:19'!
sumarPagoAPersona: unaPersona
	(self detectarSocio: unaPersona) tipoDeSocio = 'VIP'
		ifTrue: [(self detectarSocio: unaPersona) cantidadPagada:  tarifaSocioVIP ] 
		ifFalse: [(self detectarSocio: unaPersona) cantidadPagada: tarifaSocio].! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 22:47'!
cantidadPagadaPor: unaPersona 
	^(self detectarSocio: unaPersona ) cantidadPagada.
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 22:45'!
detectarSocio: unaPersona 
 ^(socios detect: [ :socio | socio nombreSocio = unaPersona ])! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 20:13'!
agregarSocioVIP: unSocio
	unSocio esVip.
	socios add: unSocio.! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 15:38'!
establecerTarifaSocioVIP: unNumero 
tarifaSocioVIP := unNumero ! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 20:04'!
cantidadDeSocios
^ socios size.! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/27/2020 00:20'!
sumarPagoAClub: unaPersona 
	recaudacionTotal := (self detectarSocio: unaPersona) tipoDeSocio = 'VIP'
		ifTrue: [ tarifaSocioVIP + recaudacionTotal.] 
		ifFalse: [tarifaSocio + recaudacionTotal. ].

! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 15:40'!
recaudacionTotal
^recaudacionTotal! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 22:35'!
nombresSocios
	^Set withAll: (socios collect: [:socio |socio nombreSocio]).


! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 15:37'!
establecerTarifaSocio: unNumero
tarifaSocio := unNumero! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 15:56'!
establecerNombre: unNombre
nombre := unNombre ! !

!Club methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 20:13'!
agregarSocio: unSocio
	unSocio noEsVip.
	socios add: unSocio.! !


Object subclass: #Socio
	instanceVariableNames: 'nombre tipoDeSocio cantidadPagada'
	classVariableNames: ''
	package: 'tp0.5-Modelo'!
!Socio commentStamp: 'ScopaAlejandro 4/26/2020 22:17' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State a one line summary. For example, "I represent a paragraph of text".

For the Respoansibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	cantidadPagada:		<Object>
	nombre:		<Object>
	tipoDeSocio:		<Object>


    Implementation Points!


!Socio methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 15:58'!
establecerNombre: unNombre 	
	nombre := unNombre ! !

!Socio methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 16:14'!
nombreSocio
	^nombre! !

!Socio methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 20:12'!
esVip
	tipoDeSocio := 'VIP'! !

!Socio methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 22:22'!
cantidadPagada: unNumero 
 cantidadPagada:=cantidadPagada + unNumero.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'ScopaAlejandro 4/26/2020 20:12'!
noEsVip
	tipoDeSocio := 'NOVIP'! !


!Socio methodsFor: 'initialization' stamp: 'ScopaAlejandro 4/26/2020 22:17'!
initialize 
	cantidadPagada := 0.! !


!Socio methodsFor: 'accessing' stamp: 'ScopaAlejandro 4/26/2020 22:23'!
cantidadPagada
 ^cantidadPagada! !

!Socio methodsFor: 'accessing' stamp: 'ScopaAlejandro 4/26/2020 20:17'!
tipoDeSocio
 ^tipoDeSocio! !
